/*
	2to1 
		by bondo ** bondo@marijuana.com ** 09-08-2k+1

	converte un wave stereo/44.1kHz/16bit in formato mono

		__parte integrante del "150'FullMusic" project__ 

	bondo::150'FMproject
*/

#include <stdio.h>
#include <string.h>

FILE *out;
FILE *in;

char nomefile[13];
char header[4];
char singolo;
char z='\0';
unsigned int pcm=0x0010, channel=0x0001;
unsigned long dimensione=0, reserved=0x00010000, samplerate=0xAC44, ads=0x015888, align=0x0002, bps=0x0010;

void scriviheader()
{


	fseek(out, 44, SEEK_SET);
	while(!feof(out)) 
	{
		fread(&singolo, 1, 1, out);
		dimensione++;
	}
	printf("\nWriting header");
	fseek(out, 0, SEEK_SET);

	strcpy(header, "RIFF");			//--- 'RIFF'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- size
	strcpy(header, "WAVE");			//--- 'WAVEfmt '
	fwrite(header, 4, 1, out);
	strcpy(header, "fmt ");
	fwrite(header, 4, 1, out);	
	fwrite(&pcm, 2, 1, out);		//--- format
	fwrite(&reserved, 4, 1, out);		//--- reserved
	fwrite(&channel, 2, 1, out);		//--- channel
	fwrite(&samplerate, 4, 1, out);		//--- sample rate
	fwrite(&ads, 4, 1, out);		//--- average data per second
	fwrite(&align, 2, 1, out);		//--- block alignment
	fwrite(&bps, 2, 1, out);		//--- bit per second
	strcpy(header, "data");			//--- 'data'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- data chunk
	fseek(out, -4, SEEK_CUR);
	fwrite(&z, 1, 1, out);

	fclose(out);
}

void mix()
{
	char bait[2];
	fseek(in, 44, SEEK_SET);
	while(!feof(in))
	{
		fread(bait, 2, 1, in);
		fwrite(bait, 2, 1, out);
		fread(bait, 2, 1, in);
		fwrite(bait, 2, 1, out);
		fread(bait, 2, 1, in);
		fread(bait, 2, 1, in);
	}
	fclose(in);
}

void ricopia(char canale[])
{
	printf("\nRicopiando...");
	char bait[2];
	if((strcmp(canale, "right"))==0) fseek(in, 44, SEEK_SET);	//si posiziona sul primo byte
	else fseek(in, 46, SEEK_SET);					//salta i 2byte del canale destro
	while(!feof(in))
	{
		fread(bait, 2, 1, in);
		fwrite(bait, 2, 1, out);
		fread(bait, 2, 1, in);		//questi si perdono
	}
	fclose(in);
}


int main(int argc, char *argv[])
{
	if(argc<2)
	{ 
		printf("\nHELP: 2to1 filename [option]");
		printf("\n\nOpzioni:");
		printf("\n -l    :considera il canale sinistro");
		printf("\n -r    :considera il canale destro");
		printf("\n -mix  :mixa i due canali (la qualit scende a 8bit)");
		return(-1);
	}

	strcpy(nomefile, argv[1]);
	nomefile[0]='_';

	out=fopen(nomefile, "w+b");
	if(out==NULL) 
	{
		printf("\nErrore creazione %s", nomefile);
		return(-1);
	}
	in=fopen(argv[1], "rb");
	if(in==NULL)
	{ 
		printf("\nErrore apertura %s", argv[1]);
		return(-1);
	}

	//--- lascia lo spazio per l'header
	fwrite(&z, 1, 44, out);

	if(argc>=3)
	{
		if((strcmp(argv[2], "-l"))==0) { ricopia("left"); scriviheader(); return(0); }
		if((strcmp(argv[2], "-r"))==0) { ricopia("right"); scriviheader(); return(0); }
		if((strcmp(argv[2], "-mix"))==0) { mix(); scriviheader(); return(0); }
		
		printf("**OPZIONE ERRATA**");
		printf("\nHELP: 2to1 filename [option]");
		printf("\n\nOpzioni:");
		printf("\n -l    :considera il canale sinistro");
		printf("\n -r    :considera il canale destro");
		printf("\n -mix  :mixa i due canali (la qualit scende a 8bit)");
		printf("\n+++ solo 16-bit/44.1kHz/stereo wavefile sono supportati +++");
		return(-1);
	}
	else { mix(); scriviheader(); return(0); }
	return(0);
}