/*	
	make 
		by bondo ** bondo@marijuana.com ** 09-08-2k+1

	crea un file masterizzabile come cd-audio con i due file uno in un canale
	e uno nell'altro canale

		__parte principale del "150'FullMusic" project__ 

	bondo::150'FMproject
*/

#include <stdio.h>
#include <string.h>

FILE *out;
FILE *l;
FILE *r;

void splitta(char *left, char *right)
{
	char data[2];
	char blank[2];
	blank[0]=0x01;blank[1]=0x00;
	l=fopen(left, "rb");
	if(l==NULL)
	{ 
		printf("\nErrore apertura %s", left);
		return(-1);
	}
	r=fopen(right, "rb");
	if(r==NULL)
	{ 
		printf("\nErrore apertura %s", right);
		return(-1);
	}
	fseek(out, 44, SEEK_SET);
	fseek(l, 44, SEEK_SET);
	fseek(r, 44, SEEK_SET);
	while((!feof(r))||(!feof(l)))
	{
		if(feof(l)) fwrite(blank, 2, 1, out);
		else 
		{
			fread(data, 2, 1, l);
			fwrite(data, 2, 1, out);
		}
		if(feof(r)) fwrite(blank, 2, 1, out);
		else
		{
			fread(data, 2, 1, r);
			fwrite(data, 2, 1, out);
		}
	}
	fclose(r);
	fclose(l);
}



int main(int argc, char *argv[])
{
	if(argc<3)
	{ 
		printf("HELP: make file1 file2 ");
		printf("\n+++ solo 16-bit/44.1kHz/mono wavefile sono supportati +++");
		return(-1);
	}

	char header[4];
	char singolo;
	char z='\0';
	unsigned int pcm=0x0010, channel=0x0002;
	unsigned long dimensione=0, reserved=0x00010000, samplerate=0xAC44, ads=0x015888, align=0x0002, bps=0x0010;

	out=fopen("burnme.wav", "w+b");
	if(out==NULL) 
	{
		printf("\nErrore creazione burnme.wav");
		return(-1);
	}

	//--- lascia lo spazio per l'header
	fwrite(&z, 1, 44, out);

	//--- crea il file 160pm
	splitta(argv[1], argv[2]);

	//--- prende la dimensione del file
	fseek(out, 44, SEEK_SET);
	while(!feof(out)) 
	{
		fread(&singolo, 1, 1, out);
		dimensione++;
	}

	//--- inizia a scrivere l'header
	printf("\nWriting header");
	fseek(out, 0, SEEK_SET);

	strcpy(header, "RIFF");			//--- 'RIFF'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- size
	strcpy(header, "WAVE");			//--- 'WAVEfmt '
	fwrite(header, 4, 1, out);
	strcpy(header, "fmt ");
	fwrite(header, 4, 1, out);	
	fwrite(&pcm, 2, 1, out);		//--- format
	fwrite(&reserved, 4, 1, out);		//--- reserved
	fwrite(&channel, 2, 1, out);		//--- channel
	fwrite(&samplerate, 4, 1, out);		//--- sample rate
	fwrite(&ads, 4, 1, out);		//--- average data per second
	fwrite(&align, 2, 1, out);		//--- block alignment
	fwrite(&bps, 2, 1, out);		//--- bit per second
	strcpy(header, "data");			//--- 'data'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- data chunk
	fseek(out, -4, SEEK_CUR);
	fwrite(&z, 1, 1, out);

	fclose(out);

	return(0);
}