/*	
	wavecat 
		by bondo ** bondo@marijuana.com ** 09-08-2k+1

	concatena pi file wave in formato mono/44.1kHz/16bit in un unico file wave

		__parte integrante del "150'FullMusic" project__ 

	bondo::150'FMproject
*/



#include <stdio.h>
#include <string.h>

FILE *out;
FILE *wave;

char nomefile[13];

void accoda(char *cosa)
{
	printf("\nProcessando: %s", cosa);
	char sample[2];
	wave=fopen(cosa, "rb");
	if(wave==NULL) printf("\nErrore apertura %s", nomefile);
	fseek(wave, 44, SEEK_SET);
	while(!feof(wave))
	{
		fread(&sample, 2, 1, wave); 
		fwrite(&sample, 2, 1, out);
	}
	fclose(wave);
}

int main(int argc, char *argv[])
{
	if(argc<2)
	{ 
		printf("HELP: wavecat file1 file2 file3 ...");
		printf("\n+++ solo 16-bit/44.1kHz/mono wavefile sono concatenabili +++");
		return(-1);
	}

	char header[4];
	char singolo;
	char z='\0';
	unsigned int pcm=0x0010, channel=0x0001;
	unsigned long dimensione=0, reserved=0x00010000, samplerate=0xAC44, ads=0x015888, align=0x0002, bps=0x0010;



	out=fopen("cat.wav", "w+b");
	if(out==NULL) 
	{
		printf("\nErrore creazione %s", nomefile);
		return(-1);
	}

	//--- riserva 44byte vuoti per l'header
	fwrite(&z, 1, 44, out);

	//--- accoda tutti i file
	for(int i=0; i<argc-1; i++) accoda(argv[i+1]);


	//--- prende la dimensione del file
	fseek(out, 44, SEEK_SET);
	while(!feof(out)) 
	{
		fread(&singolo, 1, 1, out);
		dimensione++;
	}

	//--- scrive l'header del file wave
	printf("\nScrivendo header...");
	fseek(out, 0, SEEK_SET);

	strcpy(header, "RIFF");			//--- 'RIFF'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- size
	strcpy(header, "WAVE");			//--- 'WAVEfmt '
	fwrite(header, 4, 1, out);
	strcpy(header, "fmt ");
	fwrite(header, 4, 1, out);	
	fwrite(&pcm, 2, 1, out);		//--- format
	fwrite(&reserved, 4, 1, out);		//--- reserved
	fwrite(&channel, 2, 1, out);		//--- channel
	fwrite(&samplerate, 4, 1, out);		//--- sample rate
	fwrite(&ads, 4, 1, out);		//--- average data per second
	fwrite(&align, 2, 1, out);		//--- block alignment
	fwrite(&bps, 2, 1, out);		//--- bit per second
	strcpy(header, "data");			//--- 'data'
	fwrite(header, 4, 1, out);
	fwrite(&dimensione, 4, 1, out);		//--- data chunk
	fseek(out, -4, SEEK_CUR);
	fwrite(&z, 1, 1, out);

	fclose(out);

	return(0);
}


	